> For the complete documentation index, see [llms.txt](https://docs.varbase.vardot.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.varbase.vardot.com/developers/understanding-varbase/drupal-cms-recipes/drupal-cms-search.md).

# Drupal CMS Search

## Description

The Drupal CMS Search recipe provides search functionality using the Search API framework with a database backend. It delivers a capable, out-of-the-box search experience without requiring external search services like Solr or Elasticsearch.

## Included Modules

Brings in the following core and contributed modules to your site:

| Module                                                                      | Purpose                                                                                                                                                 |
| --------------------------------------------------------------------------- | ------------------------------------------------------------------------------------------------------------------------------------------------------- |
| **Automated Cron** *(in Drupal core)*                                       | Provides an automated way to run cron jobs, by executing them at the end of a server response.                                                          |
| **Block** *(in Drupal core)*                                                | Allows users to configure blocks (containing content, forms, etc.) and to place them in the regions of a theme.                                         |
| [**Drupal Canvas**](https://www.drupal.org/project/canvas)                  | Empowers content creators to build experiences by composing components, with as much freedom as site builders allow, all without needing to write code. |
| [**ECA Config**](https://www.drupal.org/project/eca)                        | Config events.                                                                                                                                          |
| [**ECA User**](https://www.drupal.org/project/eca)                          | User events, conditions and actions.                                                                                                                    |
| **Node** *(in Drupal core)*                                                 | Manages the creation, configuration, and display of the main site content.                                                                              |
| [**Search API**](https://www.drupal.org/project/search_api)                 | Provides a generic framework for modules offering search capabilities.                                                                                  |
| [**Database Search**](https://www.drupal.org/project/search_api)            | Offers an implementation of the Search API that uses database tables for indexing content.                                                              |
| [**Search API Exclude**](https://www.drupal.org/project/search_api_exclude) | Allows users to exclude certain nodes from being indexed.                                                                                               |
| **Views** *(in Drupal core)*                                                | Provides a framework to fetch information from the database and to display it in different formats.                                                     |

## Included Themes

| Theme                                                     | Description                                                         |
| --------------------------------------------------------- | ------------------------------------------------------------------- |
| [**Canvas Stark**](https://www.drupal.org/project/canvas) | A plain theme by Drupal Canvas using the semi-coupled theme engine. |

## Installation

Apply the recipe using Drush:

```bash
ddev drush recipe ../recipes/drupal_cms_search
```

## Usage

After installation, a search index is created using the database backend. Content is automatically indexed as it is created or updated. The Search API Exclude module allows administrators to mark specific content as excluded from search results when needed. Site builders can customize the search display and results layout through the provided views and Canvas configurations.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.varbase.vardot.com/developers/understanding-varbase/drupal-cms-recipes/drupal-cms-search.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
